Test2::Compare::Negatable(3pm)

NAME
Test2::Compare::Negatable - Poor mans 'role' for compare objects that can be negated.

DESCRIPTION
Using this package inside an Test2::Compare::Base subclass will overload "!$obj" and import clone_negate() and toggle_negate().

WHY?
Until perl 5.18 the 'fallback' parameter to overload would not be inherited, so we cannot use inheritance for the behavior we actually want. This module works around the problem by emulating the "use overload" call we want for each consumer class.

ATTRIBUTES

$bool = $obj->negate
$obj->set_negate($bool)
$attr = NEGATE()
    The NEGATE attribute will be added via Test2::Util::HashBase.

METHODS

$clone = $obj->clone_negate()
    Create a shallow copy of the object, and call "toggle_negate" on it.

$obj->toggle_negate()
    Toggle the negate attribute. If the attribute was on it will now be off, if it was off it will now be on.

SOURCE
The source code repository for Test2-Suite can be found at https://github.com/Test-More/Test2-Suite/.

MAINTAINERS

Chad Granum <exodist@cpan.org>

AUTHORS
Chad Granum <exodist@cpan.org>

COPYRIGHT
Copyright 2018 Chad Granum <exodist@cpan.org>.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

See http://dev.perl.org/licenses/